//----------------------------------------------------------------------------
// SChart.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: SChart.pas
//----------------------------------------------------------------------------
#ifndef SChartHPP
#define SChartHPP
//----------------------------------------------------------------------------
#include <Menus.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Schart
{
//-- type declarations -------------------------------------------------------
enum TCStatus { csNone, csAll, csData };

enum TCKind { ckLine, ckBar, ckPie, ckArea, ckSBar, ckSArea, ckS100Bar, ckS100Area, ckHBar, ckSHBar, 
	ckS100HBar };

enum TCOption { coBarNoGap, coLineShowMarker, coLineStair, coPieShowLabel, coPieShowPercent, coRotateBottomLabel 
	};

typedef Set<TCOption, coBarNoGap, coRotateBottomLabel>  TCOptions;

enum THintOption { hoSeries, hoPoint, hoValue, hoPercent };

typedef Set<THintOption, hoSeries, hoPercent>  THintOptions;

enum TAxisOption { aoLabel, aoTick, aoGrid };

typedef Set<TAxisOption, aoLabel, aoGrid>  TAxisOptions;

enum TLegendAlignment { laLeft, laRight, laTop, laBottom };

enum TMarkerStyle { msNone, msSquare, msDiamond, msUpTri, msDownTri, msRound };

enum TCMode { cmDraw, cmCalcPos };

enum TClear { clAll, clDataValue, clSeriesLabel, clPointLabel };

typedef double TDoubleArray[288];

typedef TDoubleArray *PDoubleArray;

typedef short TSmallIntArray[576];

typedef TSmallIntArray *PSmallIntArray;

typedef Graphics::TColor TColorArray[24];

typedef TColorArray *PColorArray;

typedef tagPOINT TPointArray[48];

typedef TPointArray *PPointArray;

struct TSArea;
typedef TSArea *PSArea;

struct TSArea
{
	int Series;
	int Point;
	int Legend;
	Windows::TRect r;
} ;

struct TCaption
{
	short x;
	short y;
	System::AnsiString text;
} ;

class __declspec(delphiclass) TSCHintWindow;
class __declspec(pascalimplementation) TSCHintWindow : public Controls::THintWindow
{
	typedef Controls::THintWindow inherited;
	
private:
	HIDESBASE MESSAGE void __fastcall WMNCHitTest(Messages::TWMNCHitTest &Message);
	
protected:
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
public:
	/* THintWindow.Create */ __fastcall virtual TSCHintWindow(Classes::TComponent* AOwner) : Controls::
		THintWindow(AOwner) { }
	
public:
	/* TCustomControl.Destroy */ __fastcall virtual ~TSCHintWindow(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TSCHintWindow(HWND ParentWindow) : Controls::THintWindow(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TLegend;
class __declspec(pascalimplementation) TLegend : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FVisible;
	bool FFrame;
	Graphics::TColor FColor;
	TLegendAlignment FAlignment;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetVisible(bool Value);
	void __fastcall SetFrame(bool Value);
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetAlignment(TLegendAlignment Value);
	
public:
	HIDESBASE void __fastcall Assign(TLegend* Source);
	void __fastcall Changed(void);
	
__published:
	__property bool Visible = {read=FVisible, write=SetVisible, nodefault};
	__property bool Frame = {read=FFrame, write=SetFrame, nodefault};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, nodefault};
	__property TLegendAlignment Alignment = {read=FAlignment, write=SetAlignment, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	/* TObject.Create */ __fastcall TLegend(void) : Classes::TPersistent() { }
	/* TObject.Destroy */ __fastcall virtual ~TLegend(void) { }
	
};

typedef void __fastcall (__closure *TGetHintEvent)(System::TObject* Sender, int ASeries, int APoint, 
	int ALegend,  System::AnsiString &Hint);

typedef void __fastcall (__closure *TClickEvent)(System::TObject* Sender, int ASeries, int APoint, int 
	ALegend);

class __declspec(delphiclass) TSChart;
class __declspec(pascalimplementation) TSChart : public Controls::TGraphicControl
{
	typedef Controls::TGraphicControl inherited;
	
private:
	int FPoint;
	int FSeries;
	TDoubleArray *FDataValue;
	TColorArray *FColor;
	TSmallIntArray *FDrawData;
	Classes::TStringList* FPointLabel;
	Classes::TStringList* FSeriesLabel;
	TSmallIntArray *FLineMarker;
	TCKind FKind;
	TCOptions FOptions;
	THintOptions FHOptions;
	TCaption FTitle;
	TCaption FTopCaption;
	TCaption FLeftCaption;
	TCaption FBottomCaption;
	Graphics::TFont* FTitleFont;
	Graphics::TColor FForeColor;
	Graphics::TColor FBackColor;
	Graphics::TColor FGridColor;
	Graphics::TColor FWallColor;
	bool FChart3D;
	int FLineWidth;
	int FBorderWidth;
	int FPercent3D;
	TLegend* FLegend;
	TAxisOptions FXAxis;
	TAxisOptions FYAxis;
	TGetHintEvent FOnGetHint;
	TClickEvent FOnClick;
	Classes::TNotifyEvent FOnChange;
	TCStatus FCStatus;
	bool FBufferedDisplay;
	bool FUpdate;
	bool FHorz;
	bool FMouseDown;
	double FMin;
	double FMax;
	int FDiv;
	int FDepth;
	int F0;
	int FLCol;
	int FLWidth;
	TSArea FSArea;
	Windows::TRect FRChart;
	Windows::TRect FRPlot;
	Windows::TRect FRLegend;
	tagPOINT FPieLabel;
	TSCHintWindow* FHint;
	bool FHF;
	tagPOINT cSize;
	void __fastcall SetDataValue(int ASeries, int APoint, double Value);
	double __fastcall GetDataValue(int ASeries, int APoint);
	HIDESBASE void __fastcall SetColor(int Index, Graphics::TColor Value);
	Graphics::TColor __fastcall GetColor(int Index);
	void __fastcall SetOptions(TCOptions Value);
	void __fastcall SetKind(TCKind Value);
	void __fastcall SetPoint(int Value);
	void __fastcall SetSeries(int Value);
	void __fastcall SetPointLabel(int APoint,  System::AnsiString Value);
	System::AnsiString __fastcall GetPointLabel(int APoint);
	void __fastcall SetSeriesLabel(int ASeries,  System::AnsiString Value);
	System::AnsiString __fastcall GetSeriesLabel(int ASeries);
	HIDESBASE void __fastcall SetText(int Index,  System::AnsiString Value);
	HIDESBASE System::AnsiString __fastcall GetText(int Index);
	void __fastcall SetTitleFont(Graphics::TFont* Value);
	void __fastcall SetBorderWidth(int Value);
	void __fastcall SetChartColor(int Index, Graphics::TColor Value);
	void __fastcall Set3D(bool Value);
	void __fastcall SetLineWidth(int Value);
	void __fastcall SetMarkerStyle(int Index, TMarkerStyle Value);
	TMarkerStyle __fastcall GetMarkerStyle(int Index);
	void __fastcall SetPercent3D(int Value);
	void __fastcall SetAxis(int Index, TAxisOptions Value);
	void __fastcall SetLegend(TLegend* Value);
	void __fastcall ReAllocData(int oldSeries, int oldPoint);
	int __fastcall CIndex(int Series, int Point);
	void __fastcall CalcMinMax(void);
	void __fastcall Calc100(void);
	tagPOINT __fastcall CalcPieSize(int Width, int Height);
	void __fastcall CalcChartArea(Graphics::TCanvas* c);
	void __fastcall CalcChart(Graphics::TCanvas* c);
	void __fastcall cdLine(void);
	void __fastcall cdPie(void);
	void __fastcall cdSBar(void);
	void __fastcall cdSArea(void);
	void __fastcall cdHBar(void);
	void __fastcall cdSHBar(void);
	void __fastcall DrawChart(Graphics::TCanvas* c);
	void __fastcall DrawCText(Graphics::TCanvas* c);
	void __fastcall DrawBackground(Graphics::TCanvas* c);
	void __fastcall DrawAxis(Graphics::TCanvas* c);
	bool __fastcall DrawLegend(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawLine(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawArea(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawBar(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawPie(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawSBar(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawSArea(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawHBar(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall DrawSHBar(Graphics::TCanvas* c, TCMode cMode, const tagPOINT &mPos, PSArea e);
	bool __fastcall GetSAreaOnPos(int X, int Y, TSArea &e);
	void __fastcall CalcHint(const tagPOINT &mPos);
	System::AnsiString __fastcall DefaultHint(const TSArea &e);
	void __fastcall DrawCSArea(const TSArea &e);
	System::AnsiString __fastcall SeriesLabel(int ASeries);
	System::AnsiString __fastcall PointLabel(int Point);
	HIDESBASE void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall TitleFontChanged(System::TObject* Sender);
	void __fastcall LegendChanged(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Message);
	virtual void __fastcall Loaded(void);
	void __fastcall RevealHint( System::AnsiString s, int x, int y);
	void __fastcall RemoveHint(void);
	
protected:
	void __fastcall UpdateChart(void);
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	void __fastcall Changed(void);
	
public:
	void __fastcall SwapSeries(int Series1, int Series2);
	void __fastcall SHLPoint(int sPoint);
	void __fastcall SHRPoint(int sPoint);
	void __fastcall CopyToBitmap(Graphics::TBitmap* &ABitmap);
	void __fastcall CopyToMetafile(Graphics::TMetafile* &AMetafile);
	double __fastcall GetPercent(int Series, int Point);
	bool __fastcall PtInChart(long X, long Y, int &ASeries, int &APoint, int &ALegend);
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	void __fastcall Clear(TClear Flag);
	__fastcall virtual TSChart(Classes::TComponent* AOwner);
	__fastcall virtual ~TSChart(void);
	__property Canvas ;
	__property double DataValues[int ASeries][int APoint] = {read=GetDataValue, write=SetDataValue};
	__property Graphics::TColor ColorValues[int AIndex] = {read=GetColor, write=SetColor};
	__property System::AnsiString PointLabels[int APoint] = {read=GetPointLabel, write=SetPointLabel};
	__property System::AnsiString SeriesLabels[int ASeries] = {read=GetSeriesLabel, write=SetSeriesLabel
		};
	__property TMarkerStyle LineMarkers[int ASeries] = {read=GetMarkerStyle, write=SetMarkerStyle};
	
__published:
	__property int NSeries = {read=FSeries, write=SetSeries, nodefault};
	__property int NPoint = {read=FPoint, write=SetPoint, nodefault};
	__property TCKind Kind = {read=FKind, write=SetKind, default=1};
	__property TCOptions Options = {read=FOptions, write=SetOptions, nodefault};
	__property THintOptions HintOptions = {read=FHOptions, write=FHOptions, nodefault};
	__property System::AnsiString Title = {read=GetText, write=SetText, index=0, nodefault};
	__property Graphics::TFont* TitleFont = {read=FTitleFont, write=SetTitleFont, nodefault};
	__property System::AnsiString TopCaption = {read=GetText, write=SetText, index=1, nodefault};
	__property System::AnsiString LeftCaption = {read=GetText, write=SetText, index=2, nodefault};
	__property System::AnsiString BottomCaption = {read=GetText, write=SetText, index=3, nodefault};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, nodefault};
	__property Graphics::TColor ForeColor = {read=FForeColor, write=SetChartColor, index=0, nodefault};
		
	__property Graphics::TColor BackColor = {read=FBackColor, write=SetChartColor, index=1, nodefault};
		
	__property Graphics::TColor GridColor = {read=FGridColor, write=SetChartColor, index=2, nodefault};
		
	__property Graphics::TColor WallColor = {read=FWallColor, write=SetChartColor, index=3, nodefault};
		
	__property bool Chart3D = {read=FChart3D, write=Set3D, nodefault};
	__property int LineWidth = {read=FLineWidth, write=SetLineWidth, nodefault};
	__property int Percent3D = {read=FPercent3D, write=SetPercent3D, nodefault};
	__property bool BufferedDisplay = {read=FBufferedDisplay, write=FBufferedDisplay, nodefault};
	__property TAxisOptions XAxis = {read=FXAxis, write=SetAxis, index=0, nodefault};
	__property TAxisOptions YAxis = {read=FYAxis, write=SetAxis, index=1, nodefault};
	__property TLegend* Legend = {read=FLegend, write=SetLegend, nodefault};
	__property TGetHintEvent OnGetHint = {read=FOnGetHint, write=FOnGetHint};
	__property TClickEvent OnClick = {read=FOnClick, write=FOnClick};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Align ;
	__property Enabled ;
	__property Font ;
	__property ParentFont ;
	__property PopupMenu ;
	__property Visible ;
	__property ShowHint ;
	__property ParentShowHint ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
};

//-- var, const, procedure ---------------------------------------------------
#define sApp "TAppBuilder"
#define sComp "SimChart v1.00"
extern Shortint sCC[14];
#define MaxSeries (Byte)(12)
#define MaxPoint (Byte)(24)
#define MaxData (Word)(288)
extern Graphics::TColor sColor[12];
extern int __fastcall MinMax(double &Min, double &Max);
extern void __fastcall Line3D(Graphics::TCanvas* c, int x1, int y1, int x2, int y2, int d, Graphics::TColor 
	fColor, Graphics::TColor bColor, bool Transparent);
extern void __fastcall Bar3D(Graphics::TCanvas* c, int x1, int y1, int x2, int y2, int d, Graphics::TColor 
	fColor, Graphics::TColor bColor, bool Top, bool Right);
extern void __fastcall Bar(Graphics::TCanvas* c, int x1, int y1, int x2, int y2, Graphics::TColor color
	);
extern Graphics::TColor __fastcall GetShadowColor(Graphics::TColor bColor);
extern void __fastcall TextOutAngle(Graphics::TCanvas* c, int x, int y, Word d,  System::AnsiString 
	s);
extern double __fastcall GetAngle(int x, int y);
extern int __fastcall GetAngleRegion(double angle);
extern System::AnsiString __fastcall EllipsifyText(Graphics::TCanvas* const c, const System::AnsiString 
	Text, int MaxWidth);
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class TAxisOptions ;
template class THintOptions ;
template class TCOptions ;

}	/* namespace Schart */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Schart;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SChart
